void CalculateSpells(clsChar* TargetStruct)
{
	int i, j, k, l;
	int* SpellProb;
	int temp;
	int* ProfileSpellDone;

	SpellProb = (int*) mallocl(Source.SpellSourceCount * sizeof(int), "CalculateSpells-SpellProb");
	ProfileSpellDone = (int*) mallocl(Source.SpellSourceCount * sizeof(int), "CalculateSpells-ProfileSpellDone");

	for (i = 0;i < TargetStruct->ClassCount;i++)
	{
		ZeroMemory(ProfileSpellDone, Source.SpellSourceCount * sizeof(int));
		for (j = 0;j <= 9;j++)
		{
			for (k = 0;k < Source.SpellSourceCount;k++)
			{
				SpellProb[k] = 0;
				if (
						(
							Source.SpellSource[k].ClassLevels[TargetStruct->Classes[i]] == j ||
							(TargetStruct->DummyClassClericSpells[i] && Source.SpellSource[k].ClassLevels[GetCharNumber("Kleriker")] == j)
						)
						&& 
					(TargetStruct->SchoolForbidden[Source.SpellSource[k].School] == 0))
				{
					SpellProb[k] = Source.SpellSource[k].Probability;
					SpellProb[k] *= SpellProb[k];
				}
				if (TargetStruct->Specialised == 1 && TargetStruct->School == Source.SpellSource[k].School) {SpellProb[k] *= 2;}
				if (Source.CharSource[TargetStruct->Classes[i]].SpontanCast2 && TargetStruct->DummyClass[i] == 0)
				{
					if (strstr(Source.SpellSource[k].Name, "WundenHeil") != 0)
					{
						SpellProb[k] = 0;
					}
					if (strstr(Source.SpellSource[k].Name, "WundenVer") != 0)
					{
						SpellProb[k] = 0;
					}
				}
			}

			if (TargetStruct->Profiled)
			{
				for (l = 0;l < Profiles[TargetStruct->Profile].SpellCount;l++)
				{
					SecureMultiply(&SpellProb[Profiles[TargetStruct->Profile].Spells[l].Spell], TargetStruct->ProfileStrength);
				}
			}
			
			for (l = 0;l < TargetStruct->SpellListCount[i][j];l++)
			{
				temp = AdvancedRand(Source.SpellSourceCount, SpellProb, sizeof(int),
					(char*) &Source.SpellSource[0].Name.buffer, sizeof(clsSpell), "Zauberspruch whlen!\n", 0, 1);
				TargetStruct->SpellList[i][j][l] = temp;

				if (TargetStruct->Profiled)
				{
					for (k = 0;k < Profiles[TargetStruct->Profile].SpellCount;k++)
					{
						if (temp == Profiles[TargetStruct->Profile].Spells[k].Spell)
						{
							if (ProfileSpellDone[temp] < Profiles[TargetStruct->Profile].Spells[k].MaxNum)
							{
								ProfileSpellDone[temp]++;
								if (ProfileSpellDone[temp] == Profiles[TargetStruct->Profile].Spells[k].MaxNum)
								{
									SpellProb[temp] = 0;
								}
							}
						}
					}
				}

				TargetStruct->HighestSpell = max(TargetStruct->HighestSpell, j);
				if (Source.CharSource[TargetStruct->Classes[i]].SpontanCast)
				{
					SpellProb[temp] = 0;
				}
				SpellProb[temp] = (SpellProb[temp] * 2) / 3;
			}
			if (Source.CharSource[TargetStruct->Classes[i]].Specialize && TargetStruct->SchoolForbidden[TargetStruct->School] == 0)
			{
				if (TargetStruct->Attributes[3] - 10 >= j)
				{
					TargetStruct->HighestSpell = max(TargetStruct->HighestSpell, j);
					for (l = 0;l < Source.SpellSourceCount;l++)
					{
						if (Source.SpellSource[l].School != TargetStruct->School)
						{
							SpellProb[l] = 0;
						}
						else
						{
							SpellProb[l] = GreaterZero(SpellProb[l]);
						}
					}
					temp = AdvancedRand(Source.SpellSourceCount, SpellProb, sizeof(int),
						(char*) &Source.SpellSource[0].Name.buffer, sizeof(clsSpell), "Zauberspruch (Spezialisierte Schule) whlen!\n", 0, 1);
					TargetStruct->SpellList[i][j][TargetStruct->SpellListCount[i][j]] = temp;
					TargetStruct->SpellListCount[i][j]++;
				}
			}
		}
		if (Source.CharSource[TargetStruct->Classes[i]].Domains)
		{
			for (j = 1;j < TargetStruct->Levels[i] / 2 + 2;j++)
			{
				if (j > 9) {break;}
				if (j > TargetStruct->Attributes[4] - 10) {break;}
				for (k = 0;k < Source.SpellSourceCount;k++)
				{
					SpellProb[k] = 0;
					for (l = 0;l < Source.SpellSource[k].DomainCount;l++)
					{
						if ((Source.SpellSource[k].Domains[l] == TargetStruct->Domains[0] ||
							Source.SpellSource[k].Domains[l] == TargetStruct->Domains[1])
							&& Source.SpellSource[k].DomainLevel == j)
						{
							SpellProb[k] = Source.SpellSource[k].Probability;
							SpellProb[k] *= SpellProb[k];
						}
					}
				}
				TargetStruct->DomainSpells[j - 1] = AdvancedRand(Source.SpellSourceCount, SpellProb, sizeof(int), (char*) &Source.SpellSource[0].Name.buffer, sizeof(clsSpell), "Domnenzauber whlen!\n", 0, 1);
				TargetStruct->DomainSpellCount = j;
			}
		}
	}

	free(SpellProb);
	free(ProfileSpellDone);
}

void CalculateSpellCount(clsChar* TargetStruct)
{
	int i, j, k;
	int firstspell;
	int SpellAttr;

	int LevelBuffer[MaxClasses];
	int LevelClassicBuffer[MaxClasses];
	int TargetChar = 0;
	int TargetLevel = 0;
	CopyMemory(LevelBuffer, TargetStruct->Levels, MaxClasses * sizeof(int));
	CopyMemory(LevelClassicBuffer, TargetStruct->LevelsClassic, MaxClasses * sizeof(int));

	for (int findhighest = 0;findhighest < 2 && (findhighest == 0 || TargetStruct->Monster == 0);findhighest++)
	{
		for (i = 0;i < 32;i++)
		{
			for (j = 0;j < 10;j++)
			{
				TargetStruct->SpellsKnownCount[i][j] = -1;
				TargetStruct->SpellListCount[i][j] = -1;
				TargetStruct->SpellsPerDayCount[i][j] = -1;
			}
		}

		if (findhighest == 0)
		{
			CopyMemory(TargetStruct->LevelsClassic, TargetStruct->Levels, 32 * sizeof(int));
		}
		else
		{
			CopyMemory(TargetStruct->LevelsClassic, LevelClassicBuffer, 32 * sizeof(int));
			for (i = 0;i < TargetStruct->ClassCount;i++)
			{
				for (j = 0;j < 10;j++)
				{
					TargetStruct->SpellsKnownCount[i][j] = -1;
					TargetStruct->SpellsPerDayCount[i][j] = -1;
				}
			}
		}
		
		for (i = 0;i < TargetStruct->ClassCount;i++)
		{
			if (Source.CharSource[TargetStruct->Classes[i]].SpellType != SpellNone)
			{
				if (TargetStruct->Levels[i] > TargetLevel)
				{
					TargetChar = i;
					TargetLevel = TargetStruct->Levels[i];
				}
			}
		}

		for (i = 0;i < TargetStruct->ClassCount;i++)
		{
			if (Source.CharSource[TargetStruct->Classes[i]].IncreaseSpellType)
			{
				TargetStruct->LevelsClassic[TargetChar] += TargetStruct->LevelsClassic[i];
			}
		}

		for (i = 0;i < TargetStruct->ClassCount;i++)
		{
			SpellAttr = -1;
			if (Source.CharSource[TargetStruct->Classes[i]].SpellType == SpellBarde)
			{
				SpellAttr = 5;
				TargetStruct->SpellsKnownCount[i][0] = (TargetStruct->LevelsClassic[i] + 3 > 6 ? 6 : TargetStruct->LevelsClassic[i] + 3);
				
				TargetStruct->SpellsPerDayCount[i][0] = 2;
				if (TargetStruct->LevelsClassic[i] > 1) {TargetStruct->SpellsPerDayCount[i][0] = 3;}
				if (TargetStruct->LevelsClassic[i] > 13) {TargetStruct->SpellsPerDayCount[i][0] = 4;}

				for (j = 1;j <= 6;j++)
				{
					if (TargetStruct->Attributes[5] >= 10 + j)
					{
						firstspell = j * 2;
						if (j > 2) {firstspell++;}
						if (TargetStruct->LevelsClassic[i] >= firstspell) {TargetStruct->SpellsKnownCount[i][j] = 2;}
						if (TargetStruct->LevelsClassic[i] >= firstspell + 1) {TargetStruct->SpellsKnownCount[i][j] = 3;}
						if (TargetStruct->LevelsClassic[i] >= firstspell + 3) {TargetStruct->SpellsKnownCount[i][j] = 4;}
						if (TargetStruct->LevelsClassic[i] >= j + 15) {TargetStruct->SpellsKnownCount[i][j] = 5;}

						if (TargetStruct->LevelsClassic[i] >= firstspell) {TargetStruct->SpellsPerDayCount[i][j] = 0;}
						if (TargetStruct->LevelsClassic[i] >= firstspell + 1) {TargetStruct->SpellsPerDayCount[i][j] = 1;}
						if (TargetStruct->LevelsClassic[i] >= firstspell + 2) {TargetStruct->SpellsPerDayCount[i][j] = 2;}
						if (TargetStruct->LevelsClassic[i] >= firstspell + 4) {TargetStruct->SpellsPerDayCount[i][j] = 3;}
						if (TargetStruct->LevelsClassic[i] >= j + 14) {TargetStruct->SpellsKnownCount[i][j] = 4;}
						if (TargetStruct->LevelsClassic[i] == 19) {TargetStruct->SpellsPerDayCount[i][6] = 3;}
					}
				}
			}

			if (Source.CharSource[TargetStruct->Classes[i]].SpellType == SpellDruid || Source.CharSource[TargetStruct->Classes[i]].SpellType == SpellCleric)
			{
				SpellAttr = 4;
				if (TargetStruct->LevelsClassic[i] > 0) {TargetStruct->SpellsPerDayCount[i][0] = 3;}
				if (TargetStruct->LevelsClassic[i] > 1) {TargetStruct->SpellsPerDayCount[i][0] = 4;}
				if (TargetStruct->LevelsClassic[i] > 3) {TargetStruct->SpellsPerDayCount[i][0] = 5;}
				if (TargetStruct->LevelsClassic[i] > 6) {TargetStruct->SpellsPerDayCount[i][0] = 6;}

				for (j = 1;j <= 9;j++)
				{
					if (TargetStruct->Attributes[4] >= 10 + j)
					{
						firstspell = j * 2;
						firstspell--;

						if (TargetStruct->LevelsClassic[i] >= firstspell) {TargetStruct->SpellsPerDayCount[i][j] = 1;}
						if (TargetStruct->LevelsClassic[i] >= firstspell + 1) {TargetStruct->SpellsPerDayCount[i][j] = 2;}
						if (TargetStruct->LevelsClassic[i] >= firstspell + 3) {TargetStruct->SpellsPerDayCount[i][j] = 3;}
						if (TargetStruct->LevelsClassic[i] >= firstspell + 6) {TargetStruct->SpellsPerDayCount[i][j] = 4;}
						if (TargetStruct->LevelsClassic[i] >= firstspell + 10) {TargetStruct->SpellsPerDayCount[i][j] = 5;}

						if (TargetStruct->LevelsClassic[i] == 19) {TargetStruct->SpellsPerDayCount[i][9] = 3;}
						if (TargetStruct->LevelsClassic[i] == 20) {TargetStruct->SpellsPerDayCount[i][8] = 4;TargetStruct->SpellsPerDayCount[i][9] = 4;}
					}
				}
			}

			if (Source.CharSource[TargetStruct->Classes[i]].SpellType == SpellSorcerer)
			{
				SpellAttr = 5;
				TargetStruct->SpellsKnownCount[i][0] = (TargetStruct->LevelsClassic[i] / 2 + 4 > 9 ? 9 : TargetStruct->LevelsClassic[i] / 2 + 4);
				
				TargetStruct->SpellsPerDayCount[i][0] = 5;
				if (TargetStruct->LevelsClassic[i] > 1) {TargetStruct->SpellsPerDayCount[i][0] = 6;}

				for (j = 1;j <= 9;j++)
				{
					if (TargetStruct->Attributes[5] >= 10 + j)
					{
						firstspell = j * 2;
						if (j < 2) {firstspell-=2;}

						if (TargetStruct->LevelsClassic[i] >= firstspell) {TargetStruct->SpellsKnownCount[i][j] = 1;}
						if (TargetStruct->LevelsClassic[i] >= firstspell + 1) {TargetStruct->SpellsKnownCount[i][j] = 2;}
						if (TargetStruct->LevelsClassic[i] >= firstspell + 3) {TargetStruct->SpellsKnownCount[i][j] = 3;}
						if (TargetStruct->LevelsClassic[i] >= firstspell + 5 && j <= 5) {TargetStruct->SpellsKnownCount[i][j] = 4;}
						if (TargetStruct->LevelsClassic[i] >= firstspell + 7 && j <= 2) {TargetStruct->SpellsKnownCount[i][j] = 5;}
						
						if (TargetStruct->LevelsClassic[i] == 20) {TargetStruct->SpellsKnownCount[i][j] = 3;}

						if (j < 2) {firstspell++;}
						
						if (TargetStruct->LevelsClassic[i] >= firstspell) {TargetStruct->SpellsPerDayCount[i][j] = 3;}
						if (TargetStruct->LevelsClassic[i] >= firstspell + 1) {TargetStruct->SpellsPerDayCount[i][j] = 4;}
						if (TargetStruct->LevelsClassic[i] >= firstspell + 2) {TargetStruct->SpellsPerDayCount[i][j] = 5;}
						if (TargetStruct->LevelsClassic[i] >= firstspell + 3) {TargetStruct->SpellsPerDayCount[i][j] = 6;}

						if (TargetStruct->LevelsClassic[i] == 19) {TargetStruct->SpellsPerDayCount[i][9] = 4;}
						if (TargetStruct->LevelsClassic[i] == 20) {TargetStruct->SpellsPerDayCount[i][9] = 6;}
					}
				}
			}

			if (Source.CharSource[TargetStruct->Classes[i]].SpellType == SpellWizard)
			{
				SpellAttr = 3;
				if (TargetStruct->LevelsClassic[i] > 0) {TargetStruct->SpellsPerDayCount[i][0] = 3;}
				if (TargetStruct->LevelsClassic[i] > 1) {TargetStruct->SpellsPerDayCount[i][0] = 4;}

				for (j = 1;j <= 9;j++)
				{
					if (TargetStruct->Attributes[3] >= 10 + j)
					{
						firstspell = j * 2;
						firstspell--;

						if (TargetStruct->LevelsClassic[i] >= firstspell) {TargetStruct->SpellsPerDayCount[i][j] = 1;}
						if (TargetStruct->LevelsClassic[i] >= firstspell + 1) {TargetStruct->SpellsPerDayCount[i][j] = 2;}
						if (TargetStruct->LevelsClassic[i] >= firstspell + 3) {TargetStruct->SpellsPerDayCount[i][j] = 3;}
						if (TargetStruct->LevelsClassic[i] >= firstspell + 6) {TargetStruct->SpellsPerDayCount[i][j] = 4;}

						if (TargetStruct->LevelsClassic[i] == 19) {TargetStruct->SpellsPerDayCount[i][9] = 3;}
						if (TargetStruct->LevelsClassic[i] == 20) {TargetStruct->SpellsPerDayCount[i][8] = 4;TargetStruct->SpellsPerDayCount[i][9] = 4;}
					}
				}
			}


			if (Source.CharSource[TargetStruct->Classes[i]].SpellType == SpellPaladin || Source.CharSource[TargetStruct->Classes[i]].SpellType == SpellRanger)
			{
				SpellAttr = 4;
				for (j = 1;j <= 4;j++)
				{
					if (TargetStruct->Attributes[4] >= 10 + j)
					{
						if (j == 1)
						{
							if (TargetStruct->LevelsClassic[i] >= 4) {TargetStruct->SpellsPerDayCount[i][j] = 0;}
							if (TargetStruct->LevelsClassic[i] >= 6) {TargetStruct->SpellsPerDayCount[i][j] = 1;}
							if (TargetStruct->LevelsClassic[i] >= 14) {TargetStruct->SpellsPerDayCount[i][j] = 2;}
							if (TargetStruct->LevelsClassic[i] >= 18) {TargetStruct->SpellsPerDayCount[i][j] = 3;}
						}
						if (j == 2)
						{
							if (TargetStruct->LevelsClassic[i] >= 8) {TargetStruct->SpellsPerDayCount[i][j] = 0;}
							if (TargetStruct->LevelsClassic[i] >= 10) {TargetStruct->SpellsPerDayCount[i][j] = 1;}
							if (TargetStruct->LevelsClassic[i] >= 16) {TargetStruct->SpellsPerDayCount[i][j] = 2;}
							if (TargetStruct->LevelsClassic[i] >= 19) {TargetStruct->SpellsPerDayCount[i][j] = 3;}
						}
						if (j == 3)
						{
							if (TargetStruct->LevelsClassic[i] >= 11) {TargetStruct->SpellsPerDayCount[i][j] = 0;}
							if (TargetStruct->LevelsClassic[i] >= 12) {TargetStruct->SpellsPerDayCount[i][j] = 1;}
							if (TargetStruct->LevelsClassic[i] >= 18) {TargetStruct->SpellsPerDayCount[i][j] = 2;}
							if (TargetStruct->LevelsClassic[i] >= 19) {TargetStruct->SpellsPerDayCount[i][j] = 3;}
						}
						if (j == 4)
						{
							if (TargetStruct->LevelsClassic[i] >= 14) {TargetStruct->SpellsPerDayCount[i][j] = 0;}
							if (TargetStruct->LevelsClassic[i] >= 15) {TargetStruct->SpellsPerDayCount[i][j] = 1;}
							if (TargetStruct->LevelsClassic[i] >= 19) {TargetStruct->SpellsPerDayCount[i][j] = 2;}
							if (TargetStruct->LevelsClassic[i] >= 20) {TargetStruct->SpellsPerDayCount[i][j] = 3;}
						}
					}
				}
			}

			if (SpellAttr > -1)
			{
				for (k = 0;k < 10;k++)
				{
					if ((signed) TargetStruct->Mods[SpellAttr] - (signed) k * 4 >= 0)
					{
						for (j = 0;j < TargetStruct->Mods[SpellAttr] - k * 4;j++)
						{
							if (TargetStruct->SpellsPerDayCount[i][j + 1] > -1)
							{
								TargetStruct->SpellsPerDayCount[i][j + 1]++;
							}
						}
					}
				}
			}

			for (k = TargetStruct->BonusSpellLevelMin;k <= TargetStruct->BonusSpellLevelMax;k++)
			{
				if (TargetStruct->SpellsPerDayCount[i][k] > -1)
				{
					TargetStruct->SpellsPerDayCount[i][k] += TargetStruct->BonusSpells;
				}
			}

			for (k = 0;k < 10;k++)
			{
				if (TargetStruct->Attributes[SpellAttr] < 10 + k)
				{
					TargetStruct->SpellsKnownCount[i][k] = 0;
					TargetStruct->SpellsPerDayCount[i][k] = 0;
				}
			}

			if (Source.CharSource[TargetStruct->Classes[i]].SpontanCast)
			{
				CopyMemory(TargetStruct->SpellListCount[i], TargetStruct->SpellsKnownCount[i], sizeof(int) * 10);
			}
			else
			{
				CopyMemory(TargetStruct->SpellListCount[i], TargetStruct->SpellsPerDayCount[i], sizeof(int) * 10);
			}
			for (j = 0;j < 9;j++)
			{
				if (TargetStruct->SpellListCount[i][j] >= 0)
				{
					TargetStruct->HighestSpell = max(j, TargetStruct->HighestSpell);
				}
			}
		}
	}

	CopyMemory(TargetStruct->Levels, LevelBuffer, 32 * sizeof(int));
	CopyMemory(TargetStruct->LevelsClassic, LevelClassicBuffer, 32 * sizeof(int));
}

void DoDomainsSpecial(clsChar* TargetStruct)
{
	int i, i2, j;
	int temp;
	int* TempProb;
	int TypeDone[5];
	int forbidcount;

	TempProb = (int*) mallocl(max(Source.DomainSourceCount, Source.SchoolSourceCount) * sizeof(int), "DoDomainsSpecial-TempProb");

	i = 0;
	for (i = 0;i < TargetStruct->ClassCount;i++)
	{
		if (Source.CharSource[TargetStruct->Classes[i]].Specialize)
		{
			i = 1;
			break;
		}
	}
	
	if (i)
		{
			i = 0;
			if (TargetStruct->Profiled)
			{
				if (Profiles[TargetStruct->Profile].PreferedSchool != GetSchoolNumber("Allgemein"))
				{
					i = 1;
				}
			}
			for (j = 0;j < TargetStruct->ClassCount;j++)
			{
				if (Source.CharSource[TargetStruct->Classes[j]].Specialize == 2)
				{
					i = 1;
				}
			}
			if (i == 1 || random(1, 2, "1: Spezialisierung auf Magierschule, 2 = Keine Spezialisierung\n") == 1)
			{
				TargetStruct->Specialised = 1;
				
				if (TargetStruct->Profiled && Profiles[TargetStruct->Profile].PreferedSchool != GetSchoolNumber("Allgemein"))
				{
					TargetStruct->School = Profiles[TargetStruct->Profile].PreferedSchool;
				}
				else
				{
					tempout[0] = 0;
					for (i = 0;i < Source.SchoolSourceCount - 1;i++)
					{
						sprintf(tempstring, "%d: %s\n", i, Source.SchoolSource[i].Name.buffer);
						strcat(tempout, tempstring);
					}
					strcat(tempout, "Schule whlen\n");
					TargetStruct->School = random(0, Source.SchoolSourceCount - 2, tempout);
				}

				for (j = 0;j < 4;j++) {TypeDone[j] = 0;}

				forbidcount = 0;
				for (j = 0;j < TargetStruct->ClassCount;j++)
				{
					if (Source.CharSource[TargetStruct->Classes[j]].Specialize)
					{
						forbidcount++;
					}
				}

				for (j = 0;j < forbidcount;j++)
				{
					if (TargetStruct->School == GetSchoolNumber("Bannzauber") || TargetStruct->School == GetSchoolNumber("Illusion") || TargetStruct->School == GetSchoolNumber("Verzauberung"))
					{
						temp = random(1, 2, "Art der zu Streichenden Schule Whlen\n");
						if (TypeDone[temp]) {temp++;if (temp > 2) {temp = 1;}}
						TypeDone[temp] = 1;
						if (temp == 1)
						{
							for (i = 0;i < Source.SchoolSourceCount;i++)
							{
								if (i == GetSchoolNumber("Bannzauber")
									|| i == GetSchoolNumber("Beschwrung")
									|| i == GetSchoolNumber("Hervorrufung")
									|| i == GetSchoolNumber("Illusion")
									|| i == GetSchoolNumber("Verwandlung")
									|| i == GetSchoolNumber("Verzauberung"))
								{
									TempProb[i] = 1;
								}
								else
								{
									TempProb[i] = 0;
								}
							}
							if (TargetStruct->School == GetSchoolNumber("Bannzauber"))
							{
								TempProb[GetSchoolNumber("Bannzauber")] = 0;
							}
							else if (TargetStruct->School == GetSchoolNumber("Illusion"))
							{
								TempProb[GetSchoolNumber("Illusion")] = 0;
							}
							else
							{
								TempProb[GetSchoolNumber("Verzauberung")] = 0;
							}
	
							temp = AdvancedRand(Source.SchoolSourceCount, TempProb, sizeof(int),
								(char*) &Source.SchoolSource[0].Name.buffer, sizeof(clsSchoolSource), "Verbotene Schule whlen!\n", 0, 1);
							TargetStruct->SchoolForbidden[temp] = 1;
						}
						else
						{
							TargetStruct->SchoolForbidden[GetSchoolNumber("Erkenntnis")] = 1;
							TargetStruct->SchoolForbidden[GetSchoolNumber("Nekromantie")] = 1;
						}
					}
					else if (TargetStruct->School == GetSchoolNumber("Beschwrung") || TargetStruct->School == GetSchoolNumber("Hervorrufung") || TargetStruct->School == GetSchoolNumber("Verwandlung"))
					{
						temp = random(1, 4, "Art der zu Streichenden Schule Whlen\n");
						if (TypeDone[temp]) {temp++;if (temp > 4) {temp = 1;}}
						TypeDone[temp] = 1;
						if (temp == 1)
						{
							if (TargetStruct->School == GetSchoolNumber("Beschwrung"))
							{
								TargetStruct->SchoolForbidden[GetSchoolNumber("Hervorrufung")] = 1;
							}
							else
							{
								TargetStruct->SchoolForbidden[GetSchoolNumber("Beschwrung")] = 1;
							}
						}
						else if (temp == 2)
						{
							for (i = 0;i < Source.SchoolSourceCount;i++)
							{
								if (i == GetSchoolNumber("Bannzauber")
									|| i == GetSchoolNumber("Illusion")
									|| i == GetSchoolNumber("Verzauberung"))
								{
									TempProb[i] = 1;
								}
								else
								{
									TempProb[i] = 0;
								}
							}
							for (i = 0;i < 2;i++)
							{
								temp = AdvancedRand(Source.SchoolSourceCount, TempProb, sizeof(int),
									(char*) &Source.SchoolSource[0].Name.buffer, sizeof(clsSchoolSource), "Verbotene Schule whlen!\n", 0, 1);
								TargetStruct->SchoolForbidden[temp] = 1;
								TempProb[temp] = 0;
							}
						}
						else if (temp == 3)
						{
							if (TargetStruct->School == GetSchoolNumber("Verwandlung"))
							{
								TargetStruct->SchoolForbidden[GetSchoolNumber("Hervorrufung")] = 1;
							}
							else
							{
								TargetStruct->SchoolForbidden[GetSchoolNumber("Verwandlung")] = 1;
							}
						}
						else
						{
							for (i = 0;i < Source.SchoolSourceCount - 1;i++)
							{
								if (i != TargetStruct->School && i != GetSchoolNumber("Allgemein"))
								{
									TempProb[i] = 1;
								}
								else
								{
									TempProb[i] = 0;
								}
							}
							for (i = 0;i < 3;i++)
							{
								temp = AdvancedRand(Source.SchoolSourceCount - 1, TempProb, sizeof(int),
									(char*) &Source.SchoolSource[0].Name.buffer, sizeof(clsSchoolSource), "Verbotene Schule whlen!\n", 0, 1);
								TargetStruct->SchoolForbidden[temp] = 1;
								TempProb[temp] = 0;
							}
						}
					}
					else if (TargetStruct->School == GetSchoolNumber("Erkenntnis") || TargetStruct->School == GetSchoolNumber("Nekromantie"))
					{
						for (i = 0;i < Source.SchoolSourceCount - 1;i++)
						{
							if (i != TargetStruct->School && TargetStruct->SchoolForbidden[i] == 0)
							{
								TempProb[i] = 1;
							}
							else
							{
								TempProb[i] = 0;
							}
						}
						temp = AdvancedRand(Source.SchoolSourceCount - 1, TempProb, sizeof(int),
							(char*) &Source.SchoolSource[0].Name.buffer, sizeof(clsSchoolSource), "Verbotene Schule whlen!\n", 0, 1);
						TargetStruct->SchoolForbidden[temp] = 1;
					}
					else
					{
						printf("Error in School: %s\n", Source.SchoolSource[TargetStruct->School].Name.buffer);
						quitprog();
					}
				}
			}
			else
			{
				TargetStruct->Specialised = 0;
			}
		}	
		else
		{
			TargetStruct->Specialised = 0;
		}

	
	for (i = 0;i < TargetStruct->ClassCount;i++)
	{
		i2 = i;
	

		if (Source.CharSource[TargetStruct->Classes[i2]].Domains && TargetStruct->Domains[0] == -1)
		{
			tempout[0] = 0;
			for (i = 0;i < Source.DomainSourceCount;i++)
			{
				sprintf(tempstring, "%d: %s\n", i, Source.DomainSource[i].Name.buffer);
				strcat(tempout, tempstring);
			}
			strcat(tempout, "1. Domne whlen!\n");

			temp = random(0, Source.DomainSourceCount - 1, tempout);
			for (i = 0;i < Source.DomainSourceCount;i++)
			{
				TempProb[i] = 1;

				if (temp == i) {
					TempProb[i] = 0;}
				if (temp == GetDomainNumber("Gutes") && i == GetDomainNumber("Bses")) {
					TempProb[i] = 0;}
				if (temp == GetDomainNumber("Bses") && i == GetDomainNumber("Gutes")) {
					TempProb[i] = 0;}
				if (temp == GetDomainNumber("Chaos") && i == GetDomainNumber("Ordnung")) {
					TempProb[i] = 0;}
				if (temp == GetDomainNumber("Ordnung") && i == GetDomainNumber("Chaos")) {
					TempProb[i] = 0;}
			}
			TargetStruct->Domains[0] = temp;
			temp = AdvancedRand(Source.DomainSourceCount, TempProb, sizeof(int),
				(char*) &Source.DomainSource[0].Name.buffer, sizeof(clsDomainSource), "2. Domne whlen!\n", 0, 1);
			TargetStruct->Domains[1] = temp;
		}

		i = i2;
	}

	free(TempProb);
}
