void SetCharSource(char** Vals, void* TargetStruct, int Number, bool header)
{
	int i;

	static int prob, tw, ga, rwref, rwwil, rwzaeh, attack, skills, prestige, maxlvl, name, attr[6], valcount;
	static int scriptpos, spellpos, incspellpos, spontanpos, domainpos, specialpos, powerpos, reqpos, skillreqpos;
	static int classfeatpos, featreqpos, bonusfeattypepos, bonusfeatpos, epicfeatpos, spellfailpos, useeffectspos;
	static int attachclasspos, noeqpos, psidispos, psicryspos, forceattackpos, forceweaponpos, naturalenhpos;

	if (header)
	{
		prob = GetValNumber(Vals, "Probability", Number);
		ga = GetValNumber(Vals, "GAType", Number);
		rwref = GetValNumber(Vals, "Ref", Number);
		rwwil = GetValNumber(Vals, "Wil", Number);
		rwzaeh = GetValNumber(Vals, "Zh", Number);
		attack = GetValNumber(Vals, "Attack", Number);
		skills = GetValNumber(Vals, "Skills", Number);
		prestige = GetValNumber(Vals, "Prest", Number);
		maxlvl = GetValNumber(Vals, "MaxLvl", Number);
		name = GetValNumber(Vals, "Name", Number);
		tw = GetValNumber(Vals, "TW", Number);
		scriptpos = GetValNumber(Vals, "EffectScript", Number);
		spellpos = GetValNumber(Vals, "SpellType", Number);
		incspellpos = GetValNumber(Vals, "IncreaseSpellType", Number);
		spontanpos = GetValNumber(Vals, "SpontanCast", Number);
		domainpos = GetValNumber(Vals, "Domains", Number);
		specialpos = GetValNumber(Vals, "Specialize", Number);
		powerpos = GetValNumber(Vals, "PowerType", Number);
		reqpos = GetValNumber(Vals, "Req", Number);
		skillreqpos = GetValNumber(Vals, "SkillReq", Number);
		classfeatpos = GetValNumber(Vals, "GiveFeats", Number);
		featreqpos = GetValNumber(Vals, "FeatReq", Number);
		bonusfeattypepos = GetValNumber(Vals, "BonusFeatType", Number);
		bonusfeatpos = GetValNumber(Vals, "BonusFeats", Number);
		epicfeatpos = GetValNumber(Vals, "EpicFeats", Number);
		spellfailpos = GetValNumber(Vals, "SpellFailure", Number);
		useeffectspos = GetValNumber(Vals, "Effects", Number);
		attachclasspos = GetValNumber(Vals, "AttachClass", Number);
		noeqpos = GetValNumber(Vals, "NoEq", Number);
		psidispos = GetValNumber(Vals, "PsiDisc", Number);
		psicryspos = GetValNumber(Vals, "PsiCrys", Number);
		forceattackpos = GetValNumber(Vals, "ForceAttack", Number);
		forceweaponpos = GetValNumber(Vals, "ForceWeaponType", Number);
		naturalenhpos = GetValNumber(Vals, "NaturalEnhence", Number);

		for (i = 0;i < 6;i++)
		{
			attr[i] = GetValNumber(Vals, GetAttributeName(i), Number);
		}
		valcount = Number;
		return;
	}

	if (Number != valcount)
	{
		printf("Invalid Number of Arguments in CharSource Database\n");
		quitprog();
	}

	((clsCharSource*) TargetStruct)->Name = Vals[name];
	sscanf(Vals[tw], "W%d", &(((clsCharSource*) TargetStruct)->TW));
	for (i = 0;i < 6;i++)
	{
		sscanf(Vals[attr[i]], "%d", &(((clsCharSource*) TargetStruct)->AttributePriority[i]));
	}
	sscanf(Vals[prob], "%d", &(((clsCharSource*) TargetStruct)->Probability));
	sscanf(Vals[ga], "%d", &(((clsCharSource*) TargetStruct)->GA));
	sscanf(Vals[rwref], "%d", &(((clsCharSource*) TargetStruct)->RWRef));
	sscanf(Vals[rwwil], "%d", &(((clsCharSource*) TargetStruct)->RWWil));
	sscanf(Vals[rwzaeh], "%d", &(((clsCharSource*) TargetStruct)->RWZaeh));
	sscanf(Vals[attack], "%d", &(((clsCharSource*) TargetStruct)->PreferedAttack));
	sscanf(Vals[skills], "%d", &(((clsCharSource*) TargetStruct)->Skills));
	sscanf(Vals[prestige], "%d", &(((clsCharSource*) TargetStruct)->Prestige));
	sscanf(Vals[maxlvl], "%d", &(((clsCharSource*) TargetStruct)->MaxLevel));
	sscanf(Vals[spellpos], "%d", &(((clsCharSource*) TargetStruct)->SpellType));
	sscanf(Vals[incspellpos], "%d", &(((clsCharSource*) TargetStruct)->IncreaseSpellType));
	
	sscanf(Vals[spontanpos], "%d", &(((clsCharSource*) TargetStruct)->SpontanCast));
	sscanf(Vals[epicfeatpos], "%d", &(((clsCharSource*) TargetStruct)->EpicFeats));

	((clsCharSource*) TargetStruct)->SpontanCast2 = ((clsCharSource*) TargetStruct)->SpontanCast / 2;
	((clsCharSource*) TargetStruct)->SpontanCast &= 1;

	sscanf(Vals[domainpos], "%d", &(((clsCharSource*) TargetStruct)->Domains));
	sscanf(Vals[specialpos], "%d", &(((clsCharSource*) TargetStruct)->Specialize));
	sscanf(Vals[powerpos], "%d", &(((clsCharSource*) TargetStruct)->PowerType));
	sscanf(Vals[spellfailpos], "%d", &(((clsCharSource*) TargetStruct)->SpellFailure));

	sscanf(Vals[useeffectspos], "%d", &(((clsCharSource*) TargetStruct)->UseEffects));

	((clsCharSource*) TargetStruct)->ReqStr = Vals[reqpos];
	((clsCharSource*) TargetStruct)->SkillStr = Vals[skillreqpos];
	((clsCharSource*) TargetStruct)->FeatStr = Vals[featreqpos];

	str_replace(asc(","), asc(" "), ((clsCharSource*) TargetStruct)->ReqStr.buffer);
	str_replace(asc(";"), 0, ((clsCharSource*) TargetStruct)->ReqStr.buffer);

	str_replace(asc(";"), 0, ((clsCharSource*) TargetStruct)->FeatStr.buffer);

	str_replace(asc(","), asc(" "), ((clsCharSource*) TargetStruct)->SkillStr.buffer);
	str_replace(asc(";"), 0, ((clsCharSource*) TargetStruct)->SkillStr.buffer);

	((clsCharSource*) TargetStruct)->BonusFeatType = Vals[bonusfeattypepos];
	str_replace(asc(";"), 0, ((clsCharSource*) TargetStruct)->BonusFeatType.buffer);
	
	((clsCharSource*) TargetStruct)->BonusFeats = Vals[bonusfeatpos];
	str_replace(asc(":"), asc(" "), ((clsCharSource*) TargetStruct)->BonusFeats.buffer);
	str_replace(asc(";"), 0, ((clsCharSource*) TargetStruct)->BonusFeats.buffer);

	((clsCharSource*) TargetStruct)->AttachClass = Vals[attachclasspos];
	sscanf(Vals[noeqpos], "%d", &(((clsCharSource*) TargetStruct)->NoEq));
	sscanf(Vals[psidispos], "%d", &(((clsCharSource*) TargetStruct)->PsionicDisciple));
	sscanf(Vals[psicryspos], "%d", &(((clsCharSource*) TargetStruct)->PsiCrystal));
	sscanf(Vals[forceattackpos], "%d", &(((clsCharSource*) TargetStruct)->ForceAttack));
	sscanf(Vals[forceweaponpos], "%d", &(((clsCharSource*) TargetStruct)->ForceWeaponType));
	sscanf(Vals[naturalenhpos], "%d", &(((clsCharSource*) TargetStruct)->NaturalEnhence));
	
	if (bnf::bnfparse(Vals[scriptpos], &(((clsCharSource*) TargetStruct)->Script)) ||
		bnf::bnfparse(Vals[classfeatpos], &(((clsCharSource*) TargetStruct)->ClassFeats)))
	{
		printf("Error in Character Script %s\n", Vals[name]);
		quitprog();
	}
}

int GetCharNumber(char* CharName)
{
	int i;
	for (i = 0;i < Source.CharSourceCount;i++)
	{
		if (Source.CharSource[i].Name == CharName)
		{
			return(i);
		}
	}
	printf("Char not found(%s)\n", CharName);
	quitprog();
	return(0);
}

void CharSourceExit()
{
	int i;
	for (i = 0;i < Source.CharSourceCount;i++)
	{
		free(Source.CharSource[i].Script);
		free(Source.CharSource[i].ClassFeats);
	}
	delete[] Source.CharSource;
}
