void SetEquipSource(char** Vals, void* TargetStruct, int Number, bool header)
{
	static int name, dmg1, dmg2, size, critical, criticalm, attack, type, etype, prob, armor, maxdex, malus, spell, metal, valcount;

	if (header)
	{
		name = GetValNumber(Vals, "Name", Number);
		dmg1 = GetValNumber(Vals, "Damage1", Number);
		dmg2 = GetValNumber(Vals, "Damage2", Number);
		size = GetValNumber(Vals, "Size", Number);
		critical = GetValNumber(Vals, "Critical", Number);
		criticalm = GetValNumber(Vals, "CriticalM", Number);
		attack = GetValNumber(Vals, "AttackType", Number);
		type = GetValNumber(Vals, "Type", Number);
		etype = GetValNumber(Vals, "EquipType", Number);
		prob = GetValNumber(Vals, "Prob", Number);
		armor = GetValNumber(Vals, "Armor", Number);
		maxdex = GetValNumber(Vals, "MaxDex", Number);
		malus = GetValNumber(Vals, "Malus", Number);
		spell = GetValNumber(Vals, "SpellF", Number);
		metal = GetValNumber(Vals, "Metal", Number);
		valcount = Number;
		return;
	}

	if (Number != valcount)
	{
		printf("Invalid Number of Arguments in Equipment Source Database\n");
		quitprog();
	}

	ZeroMemory(TargetStruct, sizeof(clsEquipSource));

	((clsEquipSource*) TargetStruct)->Name = Vals[name];
	sscanf(Vals[dmg1], "%d", &(((clsEquipSource*) TargetStruct)->Damage1));
	sscanf(Vals[dmg2], "W%d", &(((clsEquipSource*) TargetStruct)->Damage2));
	(((clsEquipSource*) TargetStruct)->Damage3) = 0;
	sscanf(Vals[size], "%d", &(((clsEquipSource*) TargetStruct)->Size));
	sscanf(Vals[critical], "%d", &(((clsEquipSource*) TargetStruct)->Critical));
	sscanf(Vals[criticalm], "%d", &(((clsEquipSource*) TargetStruct)->CriticalMultiplier));
	sscanf(Vals[attack], "%d", &(((clsEquipSource*) TargetStruct)->AttackType));
	sscanf(Vals[type], "%d", &(((clsEquipSource*) TargetStruct)->Type));
	sscanf(Vals[etype], "%d", &(((clsEquipSource*) TargetStruct)->EquipType));	
	sscanf(Vals[prob], "%d", &(((clsEquipSource*) TargetStruct)->StdProb));	
	sscanf(Vals[armor], "%d", &(((clsEquipSource*) TargetStruct)->Armor));	
	sscanf(Vals[maxdex], "%d", &(((clsEquipSource*) TargetStruct)->MaxDex));	
	sscanf(Vals[malus], "%d", &(((clsEquipSource*) TargetStruct)->Malus));	
	sscanf(Vals[spell], "%d", &(((clsEquipSource*) TargetStruct)->SpellFailure));	
	sscanf(Vals[metal], "%d", &(((clsEquipSource*) TargetStruct)->Metallic));
}

void SetWProbSource(char** Vals, void* TargetStruct, int Number, bool header)
{
	int i, j;
	static int ClassPosition[128];
	static int RacePosition[128];
	static int specialpos;
	static int name, valcount;

	TargetStruct = 0;

	if (header)
	{
		for (i = 0;i < Source.CharSourceCount;i++)
		{
			ClassPosition[i] = GetValNumber(Vals, Source.CharSource[i].Name.buffer, Number);
		}
		for (i = 0;i < Source.RaceSourceCount;i++)
		{
			RacePosition[i] = GetValNumber(Vals, Source.RaceSource[i].Name.buffer, Number);
		}
		name = GetValNumber(Vals, "Name", Number);
		specialpos = GetValNumber(Vals, "SpecialType", Number);
		valcount = Number;
		return;
	}

	if (Number != valcount)
	{
		printf("Invalid Number of Arguments in Equipment Source Database\n");
		quitprog();
	}

	for (i = 0;i < Source.EquipSourceCount;i++)
	{
		if (Source.EquipSource[i].Name == Vals[name])
		{
			sscanf(Vals[specialpos], "%d", &Source.EquipSource[i].SpecialType );

			Source.EquipSource[i].Probability = (int*) mallocl(Source.CharSourceCount * sizeof(int), "SetWProbSource-Prob");
			Source.EquipSource[i].RaceProbability = (int*) mallocl(Source.RaceSourceCount * sizeof(int), "SetWProbSource-RaceProb"
				);

			for (j = 0;j < Source.CharSourceCount;j++)
			{
				sscanf(Vals[ClassPosition[j]], "%d", &Source.EquipSource[i].Probability[j]);
			}
			for (j = 0;j < Source.RaceSourceCount;j++)
			{
				sscanf(Vals[RacePosition[j]], "%d", &Source.EquipSource[i].RaceProbability[j]);
			}
			return;
		}
	}
	printf("Could not find Equipment %s\n", Vals[0]);
	quitprog();
}

int GetEquipNumber(char* EquipName)
{
	int i;
	for (i = 0;i < Source.EquipSourceCount;i++)
	{
		if (Source.EquipSource[i].Name == EquipName)
		{
			return(i);
		}
	}
	printf("Equipment not found(%s)\n", EquipName);
	quitprog();
	return(0);
}

void EquipSourceExit()
{
	int i;
	for (i = 0;i < Source.EquipSourceCount;i++)
	{
		if (Source.EquipSource[i].Probability)
		{
			free(Source.EquipSource[i].Probability);
		}
		if (Source.EquipSource[i].RaceProbability)
		{
			free(Source.EquipSource[i].RaceProbability);
		}
	}
	delete[] Source.EquipSource;
}
