void SetSpellSource(char** Vals, void* TargetStruct, int Number, bool header)
{
	int i;
	static int ClassPosition[128];
	static int DomainPos[2], DomainLevelPos, SchoolPos, ProbabilityPos, name;

	if (Number != 12)
	{
		printf("Invalid Number of Arguments in Spell Source Database\n");
		quitprog();
	}
	
	if (header)
	{
		for (i = 0;i < Source.CharSourceCount;i++)
		{
			if (Source.CharSource[i].SpellType != -1)
			{
				if (Source.CharSource[i].SpellType == SpellSorcerer || Source.CharSource[i].SpellType == SpellWizard)
				{
					ClassPosition[i] = GetValNumber(Vals, "Magier", Number);
				}
				else if (Source.CharSource[i].SpellType == SpellCleric)
				{
					ClassPosition[i] = GetValNumber(Vals, "Kleriker", Number);
				}
				else if (Source.CharSource[i].SpellType == SpellDruid)
				{
					ClassPosition[i] = GetValNumber(Vals, "Druide", Number);
				}
				else if (Source.CharSource[i].SpellType == SpellBarde)
				{
					ClassPosition[i] = GetValNumber(Vals, "Barde", Number);
				}
				else if (Source.CharSource[i].SpellType == SpellPaladin)
				{
					ClassPosition[i] = GetValNumber(Vals, "Paladin", Number);
				}
				else if (Source.CharSource[i].SpellType == SpellRanger)
				{
					ClassPosition[i] = GetValNumber(Vals, "Waldlufer", Number);
				}
			}
			else
			{
				ClassPosition[i] = -1;
			}
		}

		DomainPos[0] = GetValNumber(Vals, "Domne", Number);
		DomainPos[1] = GetValNumber(Vals, "Domne2", Number);
		DomainLevelPos = GetValNumber(Vals, "DomneL", Number);
		SchoolPos = GetValNumber(Vals, "Schule", Number);
		ProbabilityPos = GetValNumber(Vals, "Probability", Number);
		name = GetValNumber(Vals, "Name", Number);

		return;
	}
	((clsSpell*) TargetStruct)->Name = Vals[name];
	((clsSpell*) TargetStruct)->ClassLevels = (int*) mallocl(Source.CharSourceCount * sizeof(int), "SetSpellSource-ClassLevels");
	for (i = 0;i < Source.CharSourceCount;i++)
	{
		if (ClassPosition[i] != -1)
		{
			sscanf(Vals[ClassPosition[i]], "%d", &(((clsSpell*) TargetStruct)->ClassLevels[i]));
		}
		else
		{
			((clsSpell*) TargetStruct)->ClassLevels[i] = -1;
		}
	}
	((clsSpell*) TargetStruct)->DomainCount = 2;
	if (strcmp(Vals[DomainPos[1]], "-") == 0)
	{
		((clsSpell*) TargetStruct)->DomainCount = 1;
	}
	if (strcmp(Vals[DomainPos[0]], "-") == 0)
	{
		((clsSpell*) TargetStruct)->DomainCount = 0;
	}

	for (i = 0;i < ((clsSpell*) TargetStruct)->DomainCount;i++)
	{
		((clsSpell*) TargetStruct)->Domains[i] = GetDomainNumber(Vals[DomainPos[i]]);
	}
		
	sscanf(Vals[DomainLevelPos], "%d", &(((clsSpell*) TargetStruct)->DomainLevel));
	((clsSpell*) TargetStruct)->School = GetSchoolNumber(Vals[SchoolPos]);
	sscanf(Vals[ProbabilityPos], "%d", &(((clsSpell*) TargetStruct)->Probability));
}

int GetSpellNumber(char* SpellName)
{
	int i;
	for (i = 0;i < Source.SpellSourceCount;i++)
	{
		if (Source.SpellSource[i].Name == SpellName)
		{
			return(i);
		}
	}
	printf("Spell not found(%s)\n", SpellName);
	quitprog();
	return(0);
}

void SpellSourceExit()
{
	int i;
	for (i = 0;i < Source.SpellSourceCount;i++)
	{
		free(Source.SpellSource[i].ClassLevels);
	}
	delete[] Source.SpellSource;
}
