#include "config.h"
#include <stdio.h>
#include <conio.h>
#include "include/cpuid.h"

extern "C" int DebugOutput;

extern "C" void ListAlloc(int Start = 1);

int DebugOutput;

#ifdef buildvsnet
namespace vcnetspace
{
	extern int __cdecl dndmain(int argc, char** argv);
}
#endif

#ifdef builddebug
namespace debugspace
{
	extern int __cdecl dndmain(int argc, char** argv);
}
#endif

#ifdef buildintel
namespace intelspace
{
	extern int __cdecl dndmain(int argc, char** argv);
}
#endif

#ifdef buildvectorc
namespace vectorcspace
{
	extern int __cdecl dndmain(int argc, char** argv);
}
#endif

#ifdef buildgcc
	extern "C" void __stdcall _Z14if_gcc_dndmaini(int dump);
#endif

extern "C" int Runtime(int Num, int argc, char** argv);
int Runtime(int Num, int argc, char** argv)
{
	int Start = Num;
	int restarted = 0;

	goto skiprestart;

restart:
	restarted = 1;
	Num++;
	Num %= 5;

	if (Num == Start)
	{
		printf("No suitable Runtime found\n");
		getchar();
		return(1);
	}

skiprestart:

	if (Num == 0)
	{
#ifdef builddebug
		printf("Running Debug Code\n");
		return(debugspace::dndmain(argc, argv));
#else
		printf("Debug Runtime not included, Trying another\n");
		goto restart;
#endif
	}

	if (Num == 1)
	{
#ifdef buildintel
		printf("Running Intel Compiler Northwood Optimized Code\n");
		if (HasSSE2() == false)
		{
			printf("WARNING, NO SSE2 Capable CPU Found\n");
			if (restarted)
			{
				goto restart;
			}
		}
		return(intelspace::dndmain(argc, argv));
#else
		printf("Intel Compiler Runtime not included, Trying another\n");
		goto restart;
#endif
	}

	if (Num == 2)
	{
#ifdef buildvectorc
		printf("Running VectorC Compiler Optimized Code\n");
		if (isAthlon() == FALSE)
		{
			printf("WARNING, NO AMD CPU FOUND\n");
			if (restarted)
			{
				goto restart;
			}
		}
		return(vectorcspace::dndmain(argc, argv));
#else
		printf("VectorC Runtime not included, Trying another\n");
		goto restart;
#endif
	}

	if (Num == 3)
	{
#ifdef buildgcc
		printf("Running GCC Compiler SSE2 Optimized Code\n");
		if (HasSSE2() == false)
		{
			printf("WARNING, NO SSE2 Capable CPU Found\n");
			if (restarted)
			{
				goto restart;
			}
		}
		_Z14if_gcc_dndmaini(0);
		return(0);
#else
		printf("GCC Runtime not included, Trying another\n");
		goto restart;
#endif
	}

	if (Num == 4)
	{
#ifdef buildvsnet
		printf("Running Visual C++ .NET Compiler Optimized Code\n");
		return(vcnetspace::dndmain(argc, argv));
#else
		printf("Visual C++ .NET Runtime not included, Trying another\n");
		goto restart;
#endif
	}

	printf("Unknown Runtime\nExiting...\n");
	getchar();
	return(1);
}

int main(int argc, char** argv)
{
	int StdRun;
	int RetVal;

	printf("DND Chargen V. 0.8d Coded by qon in 2k4\n\n");

	if (argc == 2)
	{
		sscanf(argv[1], "%d", &StdRun);
		printf("Runtime choosen by Argument\n");
	}
	else if (HasSSE2())
	{
		printf("SSE2 capable CPU found, using Intel Compiler Runtime\n");
		StdRun = 1;
	}
	else
	{
		printf("No SSE2 capable CPU found, using Microsoft Compiler Generic Runtime\n");
		StdRun = 4;
	}

	RetVal = Runtime(StdRun, argc, argv);

#ifdef malloclog
	ListAlloc();
#endif

	while (kbhit()) {getch();}
	if (RetVal == 1)
	{
		printf("Aborting...\n");
		getchar();
	}
	else
	{
		printf("\nExiting...\n");
	}
	return(RetVal);
}
