#include "config.h"

#ifdef malloclog

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <windows.h>

extern "C" void* mallocloga(int size, char* Ident);
extern "C" void freeloga(void* Pointer);
extern "C" int MallocLogCount;
extern "C" void ListAlloc(int Start = 1);

#define MaxMalloc 131072

struct structMallocLog
{
	void* Pointer;
	char Ident[256];
	int Size;
	int ID;
};

structMallocLog MallocLogs[MaxMalloc];
int MallocLogCount = 0;
int MallocID = 0;

extern "C" int MaxAlloc;
int MaxAlloc = 0;

void ListAlloc(int Start)
{
	int i;

	bool found = false;

	if (MallocLogCount > Start)
	{
		for (i = Start;i <= MallocLogCount;i++)
		{
			if (found == false)
			{
				printf("Memmory Leak Found\n\n");
				found = true;
			}
			printf("\t%d\t:%30s (%8d - %5d)  ", i, MallocLogs[i].Ident, MallocLogs[i].ID, MallocLogs[i].Size);
			if (strlen((char*) MallocLogs[i].Pointer) < 50)
			{
				printf("%s", MallocLogs[i].Pointer);
			}
			else
			{
				printf("String Size: %d", strlen((char*) MallocLogs[i].Pointer));
			}
			printf("\n");
		}
		if (found)
		{
			throw("ListAlloc");
		}
	}
}


void* mallocloga(int size, char* Ident)
{
	void* tmp;
	tmp = malloc(size);

	if (tmp == 0)
	{
		printf("Memmory Allocation Error\n");
		throw("mallocloga");
	}

	if (MallocLogCount < MaxMalloc)
	{
		MallocLogCount++;
		if (MallocLogCount > MaxAlloc)
		{
			MaxAlloc = MallocLogCount;
		}
		MallocLogs[MallocLogCount].ID = MallocID++;
		MallocLogs[MallocLogCount].Pointer = tmp;
		MallocLogs[MallocLogCount].Size = size;
		strcpy(MallocLogs[MallocLogCount].Ident, Ident);
	}
	else
	{
		printf("Could not log Memory Allocation\n");
		throw("mallocloga");
	}
	return(tmp);
}

void freeloga(void* Pointer)
{
	int i;
	bool found = false;

	for (i = MallocLogCount;i > 0;i--)
	{
		if (MallocLogs[i].Pointer == Pointer)
		{
			if (i < MallocLogCount)
			{
				CopyMemory(&MallocLogs[i], &MallocLogs[MallocLogCount], sizeof(structMallocLog));
			}
			found = true;
			MallocLogCount--;
			break;
		}
	}
	if (!found)
	{
		printf("Freed On non allocated Block\n");
		throw("freeloga");
	}
	else
	{
		free(Pointer);
	}
}

#endif